﻿package implement

import (
	"code.fnuoos.com/EggPlanet/egg_models.git/src/dao"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_models.git/utils/logx"
	"fmt"
	"xorm.io/xorm"
)

func NewEggEnergyUserWatchRecordsDb(engine *xorm.Engine) dao.EggEnergyUserWatchRecordsDao {
	return &EggEnergyUserWatchRecordsDb{Db: engine}
}

type EggEnergyUserWatchRecordsDb struct {
	Db *xorm.Engine
}

func (e EggEnergyUserWatchRecordsDb) EggEnergyUserWatchRecordsInsert(userWatchRecords *model.EggEnergyUserWatchRecords) (int64, error) {
	_, err := e.Db.InsertOne(userWatchRecords)
	if err != nil {
		return 0, err
	}
	return userWatchRecords.Id, nil
}

func (e EggEnergyUserWatchRecordsDb) EggEnergyUserWatchRecordsUpdate(id interface{}, userWatchRecords *model.EggEnergyUserWatchRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = e.Db.Where("id=?", id).Cols(forceColums...).Update(userWatchRecords)
	} else {
		affected, err = e.Db.Where("id=?", id).Update(userWatchRecords)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (e EggEnergyUserWatchRecordsDb) EggEnergyUserWatchRecordsGetOneByParams(params map[string]interface{}) (*model.EggEnergyUserWatchRecords, error) {
	var m model.EggEnergyUserWatchRecords
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := e.Db.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if !has {
		return nil, nil
	}
	return &m, nil
}
