﻿package implement

import (
	"code.fnuoos.com/EggPlanet/egg_models.git/src/dao"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_models.git/utils/logx"
	"xorm.io/xorm"
)

func NewWxUserInfoDb(engine *xorm.Engine) dao.WxUserInfoDao {
	return &WxUserInfoDb{Db: engine}
}

type WxUserInfoDb struct {
	Db *xorm.Engine
}

func (w WxUserInfoDb) GetWxUserInfo(uid int64) (m *model.WxUserInfo, err error) {
	m = new(model.WxUserInfo)
	has, err := w.Db.Where("uid = ?", uid).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (w WxUserInfoDb) UpdateWxUserInfo(m *model.WxUserInfo, columns ...string) (int64, error) {
	affected, err := w.Db.Where("id =?", m.Id).Cols(columns...).Update(m)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (w WxUserInfoDb) WxUserInfoInsert(m *model.WxUserInfo) (int, error) {
	_, err := w.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}
